
;;;----------------------------------------------------------------------
;;; Example 1a (rect-plate brass)
;;; plate - hammer - strike with plotting
;;;----------------------------------------------------------------------

(new)
(multi)
(set-sample-rate 44100)

(defun midi2hz (x) (* 440 (expt 2 (/ (- x 69) 12))))

;;;----------------------------------------------------------------------
;;; objects
;;;----------------------------------------------------------------------

(setq my-plate 
               (make-object 'rect-plate
               (thickness 0.2)
               (modes 160)
               (density 8500)
               (young 1.04e11)
               (freq-loss 0.4)
               (const-loss 0.3)))

(set-pitch my-plate 'size (midi2hz 24)) 

(setq my-hammer (make-object 'mono-two-mass))

;;;----------------------------------------------------------------------
;;; controllers
;;;----------------------------------------------------------------------

(setq hammer-ctrl (make-controller 'envelope 1 (list(list 0 0.1)
												(list 0.1 0)
												(list 0.15 0.1)
                                                (list 0.6 0.1))))

;;;----------------------------------------------------------------------
;;; access 
;;;----------------------------------------------------------------------

(setq my-plate-out1 (make-access my-plate (const 0.2 0.2) 'normal))
(setq my-plate-out2 (make-access my-plate (const 0.8 0.8) 'normal))

(setq my-plate-hit (make-access my-plate (const 0.6 0.7) 'normal))

(setq my-hammer-tip (make-access my-hammer (const 1) 'trans0))
(setq my-hammer-top (make-access my-hammer (const 0) 'trans0))

;;;----------------------------------------------------------------------
;;; connections
;;;----------------------------------------------------------------------
                                       
(make-connection 'position my-hammer-top hammer-ctrl)

(make-connection 'strike my-plate-hit 0 my-hammer-tip .1)

(defvar graph)
(setq graph (make-plot))

(plot-value graph "hammer"  (make-controller 'access-position 1 my-hammer-tip))


;;;----------------------------------------------------------------------
;;; listening point on plate
;;;----------------------------------------------------------------------

(make-point-output my-plate-out1 0 (const 1))
(make-point-output my-plate-out2 1 (const 1))

;;;----------------------------------------------------------------------
;;; run the synthesis and play the sound
;;;----------------------------------------------------------------------

(run 5)

(plot graph "hammer movement" 0 0.09 .155 -.001 .001)

(play)

