
;;;----------------------------------------------------------------------
;;; Example 1b (rect-plate glass)
;;; plate - hammer - strike
;;;----------------------------------------------------------------------


(new)
(set-sample-rate 44100)

(defun midi2hz (x) (* 440 (expt 2 (/ (- x 69) 12))))

;;;----------------------------------------------------------------------
;;; objects
;;;----------------------------------------------------------------------

(setq my-plate 
               (make-object 'rect-plate
               (thickness 0.01)
               (modes 40)
               (density 2300)
               (young 6.02e11)
               (freq-loss 0.1)
               (const-loss 0.3)))

(set-pitch my-plate 'size (midi2hz 84)) 

(setq my-hammer (make-object 'mono-two-mass))

;;;----------------------------------------------------------------------
;;; controllers
;;;----------------------------------------------------------------------

(setq hammer-ctrl (make-controller 'envelope 1 (list(list 0 0.1)
												(list 0.1 0)
												(list 0.15 0.1)
                                                (list 0.6 0.1))))
;;;----------------------------------------------------------------------
;;;access 
;;;----------------------------------------------------------------------


(setq my-plate-out1 (make-access my-plate (const 0.2 0.2) 'normal))
(setq my-plate-out2 (make-access my-plate (const 0.8 0.8) 'normal))

(setq my-plate-hit (make-access my-plate (const 0.2 0.3) 'normal))

(setq my-hammer-tip (make-access my-hammer (const 1) 'trans0))
(setq my-hammer-top (make-access my-hammer (const 0) 'trans0))

;;;----------------------------------------------------------------------
;;;connections
;;;----------------------------------------------------------------------
                                       
(make-connection 'position my-hammer-top hammer-ctrl)

(make-connection 'strike my-hammer-tip .1 my-plate-hit 0)

;;;----------------------------------------------------------------------
;;; listening point on plate
;;;----------------------------------------------------------------------

(make-point-output my-plate-out1 0 (const 1))
(make-point-output my-plate-out2 1 (const 1))

;;;----------------------------------------------------------------------
;;; run the synthesis and play the sound
;;;----------------------------------------------------------------------


(run 5)
(play)

