
;;;----------------------------------------------------------------------
;;; Example 1d
;;; plate - force
;;;----------------------------------------------------------------------

(new)
(multi)
(set-sample-rate 44100)

(defun midi2hz (x) (* 440 (expt 2 (/ (- x 69) 12))))

;;;----------------------------------------------------------------------
;;; objects
;;;----------------------------------------------------------------------

(defvar my-plate)
(setq my-plate 
               (make-object 'rect-plate
               (thickness 0.2)
               (modes 160)
               (density 8500)
               (young 1.04e11)
               (freq-loss 0.4)
               (const-loss 0.3)))

(set-pitch my-plate 'size (midi2hz 24)) 

;(save-object my-string "/Volumes/DataStor/_Vorlesungen_Seminare/physical_modeling/ex_lisp/01d-my-plate-object.txt")

;;;----------------------------------------------------------------------
;;; controllers
;;;----------------------------------------------------------------------

(defvar my-controller)
(setq my-controller (make-controller 'envelope 1  
							(list 	(list 0 0)
									(list 0.01 -5)
									(list 0.02 0))))

;;;----------------------------------------------------------------------
;;; access 
;;;----------------------------------------------------------------------

(defvar my-plate-out1)
(setq my-plate-out1 (make-access my-plate (const 0.2 0.2) 'normal))
(defvar my-plate-out2)
(setq my-plate-out2 (make-access my-plate (const 0.8 0.8) 'normal))

(defvar my-plate-force)
(setq my-plate-force (make-access my-plate (const 0.5 0.5) 'normal))

;;;----------------------------------------------------------------------
;;; connections
;;;----------------------------------------------------------------------

(make-connection 'force my-plate-force my-controller)

;;;----------------------------------------------------------------------
;;; listening points on plate
;;;----------------------------------------------------------------------

(make-point-output my-plate-out1 0 (const 1))
(make-point-output my-plate-out2 1 (const 1))

;;;----------------------------------------------------------------------
;;; run the synthesis and play the sound
;;;----------------------------------------------------------------------
   
(run 6)   
(play)
