
;;;----------------------------------------------------------------------
;;; Example 2b (rect-membrane)
;;; membrane - hammer - felt
;;;----------------------------------------------------------------------

(new)
(multi)
(set-sample-rate 44100)

(defun midi2hz (x) (* 440 (expt 2 (/ (- x 69) 12))))

;;;----------------------------------------------------------------------
;;; objects
;;;----------------------------------------------------------------------

(setq my-membrane 
               	(make-object 'rect-membrane
               	(modes 80)
				(length0 1.0)
				(length1 1.0)
               	(tension 1000)
               	(mass 0.01)
               	(freq-loss 0.4)
               	(const-loss 0.3)))


(set-pitch my-membrane 'tension (midi2hz 36)) 

(setq my-hammer (make-object 'bi-two-mass))

;;;----------------------------------------------------------------------
;;; controllers
;;;----------------------------------------------------------------------


;;;----------------------------------------------------------------------
;;; access 
;;;----------------------------------------------------------------------

(defvar my-membrane-out1)
(setq my-membrane-out1 (make-access my-membrane (const 0.2 0.2) 'normal))
(defvar my-membrane-out2)
(setq my-membrane-out2 (make-access my-membrane (const 0.8 0.8) 'normal))

(setq my-membrane-hit (make-access my-membrane (const 0.2 0.3) 'normal))

(setq my-hammer-hit (make-access my-hammer (const 1) 'trans0))
    
(setq my-hammer-mov (make-access my-hammer (const 0) 'trans0))

;;;----------------------------------------------------------------------
;;; connections
;;;----------------------------------------------------------------------
                                       

(make-connection 'felt my-hammer-hit .1  my-membrane-hit 0 
                   	(const .01)     	;; thickness
                   	(const 1e+9)     	;;  F0
                   	(const 3.0)      	;;  alpha
                   	(const 0.83)     	;;  epsilon
                   	(const 35e-04)		;;  tau
					(const 0.1)   		;;	weight
                   	)

(make-connection 'position my-hammer-mov
                 (make-controller 'envelope 1
                                  (list (list 0.00   .3)
                                        (list 0.05  -.001)
                                        (list 0.10   .3)
                                        (list 0.50   .3)
                                        (list 0.55   .3)
                                        (list 0.60   .3))))


;;;----------------------------------------------------------------------
;;; listening point on plate
;;;----------------------------------------------------------------------

(make-point-output my-membrane-out1 0 (const 1))
(make-point-output my-membrane-out2 1 (const 1))

;;;----------------------------------------------------------------------
;;; run the synthesis and play the sound
;;;----------------------------------------------------------------------

(run 5)
(play)

