
;;;----------------------------------------------------------------------
;;; Example 2c2
;;; circ-membrane - force
;;;----------------------------------------------------------------------

(new)
(multi)
(set-sample-rate 44100)

(defun midi2hz (x) (* 440 (expt 2 (/ (- x 69) 12))))

;;;----------------------------------------------------------------------
;;; objects
;;;----------------------------------------------------------------------

(defvar my-membrane)
(setq my-membrane 
               	(make-object 'circ-membrane
               	(modes 80)
				(radius 0.5)
              	(tension 1000)
               	(mass 0.01)
               	(freq-loss 0.4)
               	(const-loss 0.3)))

(set-pitch my-membrane 'tension (midi2hz 48)) 


;(save-object my-string "/Volumes/DataStor/_Vorlesungen_Seminare/physical_modeling/ex_lisp/02c-my-membrane-object.txt")

;;;----------------------------------------------------------------------
;;; controllers
;;;----------------------------------------------------------------------

(defvar my-controller)
(setq my-controller (make-controller 'envelope 1  
							(list 	(list 0 0)
									(list 0.01 -5)
									(list 0.02 0))))

;;;----------------------------------------------------------------------
;;; access 
;;;----------------------------------------------------------------------

(defvar my-membrane-out1)
(setq my-membrane-out1 (make-access my-membrane (const 0.2 0.2) 'normal))
(defvar my-membrane-out2)
(setq my-membrane-out2 (make-access my-membrane (const 0.8 0.8) 'normal))

(defvar my-membrane-force)
(setq my-membrane-force (make-access my-membrane (const 0.5 0.5) 'normal))

;;;----------------------------------------------------------------------
;;; connections
;;;----------------------------------------------------------------------

(make-connection 'force my-membrane-force my-controller)

;;;----------------------------------------------------------------------
;;; listening points on plate
;;;----------------------------------------------------------------------

(make-point-output my-membrane-out1 0 (const 1))
(make-point-output my-membrane-out2 1 (const 1))

;;;----------------------------------------------------------------------
;;; run the synthesis and play the sound
;;;----------------------------------------------------------------------
   
(run 6)   
(play)
