
;;;----------------------------------------------------------------------
;;; Example 3a
;;; string - force
;;;----------------------------------------------------------------------

(new)
(multi)
(set-sample-rate 44100)

(defun midi2hz (x) (* 440 (expt 2 (/ (- x 69) 12))))

;;;----------------------------------------------------------------------
;;; objects
;;;----------------------------------------------------------------------

(defvar my-string)
(setq my-string (make-object 'mono-string
      								(modes 80)
      								(length 1)
      								(tension 100)									(density 1000)
      								(radius 0.001)
      								(young 1e9)
      								(freq-loss 1)
      								(const-loss 1)))

(set-pitch my-string 'length (midi2hz 60)) 

;(save-object my-string "/Volumes/DataStor/_Vorlesungen_Seminare/physical_modeling/ex_lisp/03a-my-string-object.txt")

;;;----------------------------------------------------------------------
;;; controllers
;;;----------------------------------------------------------------------

(defvar my-controller)
(setq my-controller (make-controller 'envelope 1  
							(list 	(list 0 0)
									(list 0.01 -5)
									(list 0.02 0))))

;;;----------------------------------------------------------------------
;;; access 
;;;----------------------------------------------------------------------

(defvar my-string-out)
(setq my-string-out (make-access my-string (const .3) 'trans0))
(defvar my-string-force)
(setq my-string-force (make-access my-string (const .6) 'trans0))

;;;----------------------------------------------------------------------
;;; connections
;;;----------------------------------------------------------------------

(make-connection 'force my-string-force my-controller)

;;;----------------------------------------------------------------------
;;; listening point on string
;;;----------------------------------------------------------------------

(make-point-output my-string-out)

;;;----------------------------------------------------------------------
;;; run the synthesis and play the sound
;;;----------------------------------------------------------------------
   
(run 2)    ;; make 2 seconds of sound
(play)
