
;;;----------------------------------------------------------------------
;;; Example 1b
;;; string - hammer - strike
;;;----------------------------------------------------------------------


(new)
(multi)
(set-sample-rate 44100)

(defun midi2hz (x) (* 440 (expt 2 (/ (- x 69) 12))))

;;;----------------------------------------------------------------------
;;; objects
;;;----------------------------------------------------------------------

(defvar my-string)
(setq my-string (make-object 'mono-string
      								(modes 80)
      								(length 1)
      								(tension 100)									(density 1000)
      								(radius 0.001)
      								(young 1e9)
      								(freq-loss 1)
      								(const-loss 1)))

(set-pitch my-string 'length (midi2hz 84)) 

(defvar my-hammer)
(setq my-hammer (make-object 'mono-two-mass))

;;;----------------------------------------------------------------------
;;; controllers
;;;----------------------------------------------------------------------

(defvar hammer-ctrl)
(setq hammer-ctrl (make-controller 'envelope 1 (list(list 0 0.1)
												(list 0.1 0)
												(list 0.15 0.1)
                                                (list 0.6 0.1))))

;;;----------------------------------------------------------------------
;;;access 
;;;----------------------------------------------------------------------

(defvar my-string-out)
(setq my-string-out (make-access my-string (const .8) 'trans0))

(defvar my-string-hit)
(setq my-string-hit (make-access my-string (const 0.1) 'trans0))

(defvar my-hammer-tip)
(setq my-hammer-tip (make-access my-hammer (const 1) 'trans0))
(setq my-hammer-top (make-access my-hammer (const 0) 'trans0))

;;;----------------------------------------------------------------------
;;;connections
;;;----------------------------------------------------------------------
                                       
(make-connection 'position my-hammer-top hammer-ctrl)

(make-connection 'strike my-hammer-tip .1 my-string-hit 0)

;;;----------------------------------------------------------------------
;;; listening point on string
;;;----------------------------------------------------------------------

(make-point-output my-string-out1 0 (const 1))

;;;----------------------------------------------------------------------
;;; run the synthesis and play the sound
;;;----------------------------------------------------------------------


(run 5)
(play)

