
;;;----------------------------------------------------------------------
;;; Example 3c
;;; string - plectrum - pluck
;;;----------------------------------------------------------------------


(new)
(multi)
(set-sample-rate 44100)

(defun midi2hz (x) (* 440 (expt 2 (/ (- x 69) 12))))

;;;----------------------------------------------------------------------
;;; objects
;;;----------------------------------------------------------------------

(defvar my-string)
(setq my-string (make-object 'mono-string
							(modes 80)
							(length 1)
							(tension 100)
							(density 1000)
							(radius 0.001)
							(young 1e9)
							(freq-loss .8)
							(const-loss .8)))

(set-pitch my-string 'tension (midi2hz 45)) 

(defvar my-plectrum)
(setq my-plectrum (make-object 'mono-two-mass))

;;;----------------------------------------------------------------------
;;; controllers
;;;----------------------------------------------------------------------

(defvar my-controller-mov)
(setq my-controller-mov (make-controller 'envelope 1  
			(list(list 0 0.1)
				(list 0.1 -0.1)
                (list 0.9 -0.1)
				(list 1.0 0.1))))
													
;;;----------------------------------------------------------------------
;;;access 
;;;----------------------------------------------------------------------

(defvar my-string-out)
(setq my-string-out (make-access my-string (const 0.2) 'trans0))
(defvar my-string-pluck)
(setq my-string-pluck (make-access my-string (const .6) 'trans0))

(defvar my-plectrum-tip)
(setq my-plectrum-tip (make-access my-plectrum (const 1) 'trans0))
(defvar my-plectrum-top)
(setq my-plectrum-top (make-access my-plectrum (const 0) 'trans0))

;;;----------------------------------------------------------------------
;;;connections
;;;----------------------------------------------------------------------

(make-connection 'pluck my-string-pluck 0 my-plectrum-tip 0.1 (const 50))
(make-connection 'position my-plectrum-top my-controller-mov) 

;;;----------------------------------------------------------------------
;;; listening point on string
;;;----------------------------------------------------------------------

(make-point-output my-string-out)

;;;----------------------------------------------------------------------
;;; run the synthesis and play the sound
;;;----------------------------------------------------------------------
   
(run 6)   
(play)
