
;;;----------------------------------------------------------------------
;;; Example 3d
;;; string - bow - bowed
;;;----------------------------------------------------------------------

(new)
(multi)

(load-component "connection")

;;;----------------------------------------------------------------------
;;; objects
;;;----------------------------------------------------------------------

(defvar my-string)
(setq my-string (make-object 'bi-string 
                             (modes 40)
                             (length .5)
                             (tension 150)
                             (density 1000)
                             (radius .001)
                             (young .001)
                             (freq-loss 1)
                             (const-loss 1)))

(defvar my-bow)
(setq my-bow (make-object 'bi-two-mass 
                          (small-mass .05)
                          (large-mass .05)
                          (stiffness0 50000)
                          (stiffness1 50000)
                          (freq-loss0 100)
                          (freq-loss1 100)
                          (const-loss0 0)
                          (const-loss1 0)))

;;;----------------------------------------------------------------------
;;;access 
;;;----------------------------------------------------------------------

(defvar my-bow-hor)
(setq my-bow-hor (make-access my-bow 1 'trans0))

(defvar my-bow-vert)
(setq my-bow-vert (make-access my-bow 1 'trans1))

(defvar my-string-hor)
(setq my-string-hor (make-access my-string .1 'trans0))

(defvar my-string-vert)
(setq my-string-vert (make-access my-string .1 'trans1))

;;;----------------------------------------------------------------------
;;;connections
;;;----------------------------------------------------------------------

(defvar my-bow-connection)
(setq my-bow-connection (make-connection 'bow
                          my-bow-vert my-bow-hor .01
                          my-string-vert my-string-hor 0
                          '(2 10 5 4)))

(defvar my-bow-hor-mov)
(setq my-bow-hor-mov (make-access my-bow (const 0) 'trans0))

(defvar my-bow-vert-mov)
(setq my-bow-vert-mov (make-access my-bow (const 0) 'trans1))

;;;----------------------------------------------------------------------
;;; controllers
;;;----------------------------------------------------------------------

(make-connection 'speed my-bow-hor-mov
                 (make-controller 'envelope 1
                                  (list (list 0.00  1)
                                        (list 0.10  4)
                                        (list 9.99  1))))

(make-connection 'position my-bow-vert-mov
                 (make-controller 'envelope 1
                                  (list (list 0.0  0.010)
                                        (list 0.2 -0.001)
                                        (list 0.4 -0.001)
                                        (list 0.5  0.010)
                                        (list 0.6  0.010)
                                        (list 0.7 -0.001)
                                        (list 1.2 -0.001)
                                        (list 1.3  0.010)
                                        (list 9.9  0.010))))

;;;----------------------------------------------------------------------
;;; listening point on string
;;;----------------------------------------------------------------------

(make-point-output (make-access my-string (const .6) 'trans0))

;;;----------------------------------------------------------------------
;;; print useful information 
;;; (this function is defined in the "connection component")
;;;----------------------------------------------------------------------

(help-bow my-bow-connection)

;;;----------------------------------------------------------------------
;;; run the synthesis and play the sound
;;;----------------------------------------------------------------------

(run 3)
(play)